/* script interpreter 
 * 
 * shige
 * 05/13 2000
 * 06/02 2000
 * shless.c
 *
 * $Id: shless.c,v 1.1 2000-09-19 15:55:15+09 shige Exp $
 */
/* 05/13 2000
 * 1)	괺ñ 1 Ԥ system Ǽ¹Ԥ롣
 * 2)	backscroll 褦ˤ
 * 3)	key Ϥϼ괺
 * 4)	key bind: 
 *        [space], ñ return, 'n': ==> ι
 *        'r': ==> ι
 *        'b': ==> ι
 *        'q': ==> λ
 *	Ǥ '3b' ߤʤΤⰷ褦ˤ
 * 5)	Ϥ less ˶ŤФline ɡ
 * 	[a] buffering ʤ stdin Ȥäȿ夲
 *	[b] comand line βɽ
 *	[c] ϥβɽ
 *	==> [b],[c] ϼ
 * 6)	ϡƹԤɽĤġȿžɽȤäꤷʤ롢ä
 *	Τɤʤ (w3m  buffer Τ褦)ɽ⥳
 *	ɥ饤षѴιԤΤޤޤåϥ
 *	餷礦ʤ
 * 06/02 2000
 * 7)	fpurge()  Solaris ˤϤʤ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFFERCLEAR


#define Maxbuff 8192
#define Maxlines 1000

enum Errorval {
    Err_too_long_line = -30,
    Err_too_many_lines,

    No_err=0,
};

#ifdef __FreeBSD__
# define FFLUSH(s) fpurge(s)
#else
# define FFLUSH(s) fflush(s)
#endif

/*####### [1] shless.c #######*/
int main(int argc,char *argv[]);
void mysystem(char *s);
char *commstr(FILE *infile,long int linespos[],int pos);
int mklinespos(FILE *infile,long int linespos[]);
void usage(char *str,int mes);

/* #define mysystem(s) usage((s),0) */
/* #define mysystem(s) system(s) */

int main(int argc,char *argv[])
{
    long int linespos[Maxlines];
    int lines,pos,initial=1;
    char c;
    FILE *infile;

    if(argc<2){ usage(NULL,1);	return 1; }
    if((infile=fopen(argv[1],"r"))==NULL){
	usage("File open error.",1);
	return 1;
    }
    if((lines=mklinespos(infile,linespos))<0)
      switch(lines){
      case Err_too_long_line: usage("Too long line exists.",0); return 1;
      case Err_too_many_lines: usage("Too long line exists.",0); return 1;
      defalut: usage("Unknown error.",0); return 1;
      }
    pos=0;
    fseek(infile,0L,SEEK_SET);
    while((c=getchar())!='q' && c!='Q'){
	switch(c){
	case 'r':
	case 'R':
	    mysystem(commstr(infile,linespos,pos));
	    break;
	case 'b':
	case 'B':
	case 'p':
	case 'P':
	    if(--pos<0){
		pos++;
		usage("TOP of the file.",0);
	    }
	    else
	      mysystem(commstr(infile,linespos,pos));
	    break;
	case ' ':
	case '\n':
	    if(initial){
		pos=0;
		mysystem(commstr(infile,linespos,pos));
	    }
	    else if(++pos>=lines){
		pos--;
		usage("BOTTOMP of the file.",0);
	    }
	    else
	      mysystem(commstr(infile,linespos,pos));
	    break;
	case 'n':
	case 'N':
	    if(++pos>=lines){
		pos--;
		usage("BOTTOM of the file.",0);
	    }
	    else
	      mysystem(commstr(infile,linespos,pos));
	    break;
	case 'g':
	    pos=0;
	    mysystem(commstr(infile,linespos,pos));
	    break;
	case 'G':
	    pos=lines-1;
	    mysystem(commstr(infile,linespos,pos));
	    break;
	default:
	    usage("Unknown key.",0);
	case 'h':
	case 'H':
	    usage("return) r) b) n) g)ǽ G)Ǹ h)Help q)λ",0);
	    break;
	}
	initial=0;
#ifdef BUFFERCLEAR
	FFLUSH(stdin);
#endif
    }
    return 0;
}

void mysystem(char *s)
{
    usage(s,0);
    system(s);
}

char *commstr(FILE *infile,long int linespos[],int pos)
{
    static char buff[Maxbuff];

    fseek(infile,linespos[pos],SEEK_SET);
    fgets(buff,Maxbuff,infile);
    buff[strlen(buff)-1]='\0';
    return buff;
}

int mklinespos(FILE *infile,long int linespos[])
{
    char buff[Maxbuff];
    int j,lines=0;
    long int pos=0L;
    
    while(fgets(buff,Maxbuff,infile)!=NULL){
	if(lines>=Maxlines) return Err_too_many_lines;
        if((j=strlen(buff))>=Maxbuff-1 && buff[Maxbuff-2]!='\n')
	  return Err_too_long_line;
	linespos[lines++]=pos;
	pos+=j;
    }
    return lines;
}

void usage(char *str,int mes)
{
    FILE *outf;
    char *mess[]={
	"Usage: shless [script file]",
	"1) [script fie]  \"-\" ΤȤɸϤɤ߹ࡣ",
	"2) ƹԤ system() Ǽ¹Ԥ롣",
	"3) '#' ǻϤޤԤϥȹԤȤߤʤ",
	"4) key bind:",
	"    n: ι ([space], [return])",
        "    r: ι",
        "    b: ι",
        "    g: ǽι",
        "    G: Ǹι",
	"    h: ",
        "    q: λ",
	NULL
    };
    int j;

    if(isatty(fileno(stdout))) outf=stdout;
    else outf=stderr;  /* stdout  redirect Ƥ */ 

    if(str!=NULL) fprintf(outf,"%s\n",str);
    if(mes)
      for(j=0;mess[j]!=NULL;j++) fprintf(outf,"%s\n",mess[j]);
}
